## gdm3 46.2

=== meson_options.txt ===
option('at-spi-registryd-dir', type: 'string', value: '', description: 'Specify the directory of at-spi-registryd.')
option('custom-conf', type: 'string', value: '', description: 'Filename to give to custom configuration file.')
option('dbus-sys', type: 'string', value: '', description: 'Where D-Bus systemd directory is.')
option('default-pam-config', type: 'combo', choices: [ 'autodetect', 'redhat', 'openembedded', 'exherbo', 'lfs', 'arch', 'none'], value: 'autodetect', description: '')
option('default-path', type: 'string', value: '/usr/local/bin:/usr/local/sbin:/usr/bin:/usr/sbin:/bin:/sbin', description: 'Path GDM will use as the user\'s default PATH.')
option('defaults-conf', type: 'string', value: '', description: 'Filename to give to defaults file.')
option('distro', type: 'string', value: 'none', description: 'Distribution name, used to detect PAM files and hook scripts.')
option('dmconfdir', type: 'string', value: '', description: 'Directory where sessions are stored.')
option('gdm-xsession', type: 'boolean', value: false, description: 'Enable installing the gdm Xsession file.')
option('gnome-settings-daemon-dir', type: 'string', value: '', description: 'Specify the directory of gnome-settings-daemon used by the chooser.')
option('group', type: 'string', value: 'gdm', description: 'GDM\'s group.')
option('initial-vt', type: 'integer', value: 1, description: 'Initial virtual terminal to use.')
option('ipv6', type: 'boolean', value: false, description: 'Enables compilation of IPv6 code.')
option('lang-file', type: 'string', value: '', description: 'File containing default language settings.')
option('libaudit', type: 'feature', value: 'auto', description: 'Add Linux audit support.')
option('logind-provider', type: 'combo', choices: ['systemd', 'elogind'], value: 'systemd', description: 'Which logind library to use.')
option('log-dir', type: 'string', value: '/var/log/gdm', description: 'Log directory.')
option('pam-mod-dir', type: 'string', value: '', description: 'Directory to install PAM modules in.')
option('pam-prefix', type: 'string', value: '', description: 'Specify where PAM files go.')
option('pid-file', type: 'string', value: '', description: 'Pid file.')
option('plymouth', type: 'feature', value: 'auto', description: 'Add plymouth support.')
option('private-dbus-dir', type: 'string', value: '', description: 'Directory for private D-Bus server sockets')
option('profiling', type: 'boolean', value: false, description: 'Enable profiling.')
option('ran-once-marker-dir', type: 'string', value: '', description: 'Ran once marker directory.')
option('run-dir', type: 'string', value: '', description: 'Runtime directory.')
option('runtime-conf', type: 'string', value: '', description: 'Filename to give to runtime configuration file.')
option('screenshot-dir', type: 'string', value: '', description: 'Directory to store greeter screenshot.')
option('selinux', type: 'feature', value: 'auto', description: 'Add SELinux support.')
option('solaris', type: 'boolean', value: false, description: 'Build for Solaris')
option('split-authentication', type: 'boolean', value: true, description: 'Enable multiple simultaneous PAM conversations during login.')
option('sysconfsubdir', type: 'string', value: 'gdm', description: 'Directory name used under sysconfdir.')
option('systemd-journal', type: 'boolean', value: true, description: 'Use journald support.')
option('systemdsystemunitdir', type: 'string', value: '', description: 'Directory for systemd service files, or \'no\' to disable.')
option('systemduserunitdir', type: 'string', value: '', description: 'Directory for systemd user service files, or \'no\' to disable.')
option('tcp-wrappers', type: 'boolean', value: false, description: 'Use TCP wrappers.')
option('udev-dir', type: 'string', value: '', description: 'Directory for udev rules file.')
option('user', type: 'string', value: 'gdm', description: 'GDM\'s username.')
option('user-display-server', type: 'boolean', value: true, description: 'Enable running X server as user.')
option('wayland-support', type: 'boolean', value: true, description: 'Enable support for wayland sessions.')
option('working-dir', type: 'string', value: '', description: 'Working directory.')
option('xauth-dir', type: 'string', value: '', description: 'XAuth cookie directory.')
option('xdmcp', type: 'feature', value: 'auto', description: 'Add XDMCP (remote login) support.')

=== debian/changelog ===
gdm3 (46.2-1ubuntu1~24.04.4) noble; urgency=medium

  * Fix fallback session with auto-login (LP: #2129777)

 -- Alessandro Astone <alessandro.astone@canonical.com>  Tue, 04 Nov 2025 11:29:29 +0100

gdm3 (46.2-1ubuntu1~24.04.3) noble; urgency=medium

  [ Tony Hsiao ]
  * Add hardware matching rule for preferring wayland (LP: #2124220)

 -- Daniel van Vugt <daniel.van.vugt@canonical.com>  Thu, 25 Sep 2025 17:14:09 +0800

gdm3 (46.2-1ubuntu1~24.04.2) noble; urgency=medium

  [ Zhaoxuan Zhai ]
  * Add retry_preferred_display_server_before_fallback.patch to fix
    the problem that the existing retry strategy cannot retry the preferred
    session when the preferred session accidentally crashes during startup
    (LP: #2120413)

  [ Daniel van Vugt ]
  * Add local-display-factory-Match-simpledrm-in-a-substring-inst.patch to
    ensure the login screen does not start before the real DRM kernel driver
    is loaded. (LP: #2115451)

  [ Tony Hsiao ]
  * Prefer Wayland if a specific environment variable is set (LP: #2124220)

 -- Daniel van Vugt <daniel.van.vugt@canonical.com>  Thu, 18 Sep 2025 17:10:23 +0800

gdm3 (46.2-1ubuntu1~24.04.1) noble; urgency=medium

  [ Marco Trevisan (Treviño) ]
  * No-change backport of stable release 46.2 (LP: #2090876)

  [ Jeremy Bícha ]
  * Branch for noble

  [ Alessandro Astone ]
  * Default nvidia hybrid laptops to Xorg (LP: #2080498):
    - Drop Revert-data-Disable-GDM-on-hybrid-graphics-laptops-with-v.patch
      The hunks that are still relevant have been split into their own patches.
    - Add Prefer-Xorg-for-all-Nvidia-versions.patch
      This diff comes directly from the dropped patch.
    - Add Drop-Nvidia-power-management-suspend-checks.patch
      This diff comes directly from the dropped patch, and is still necessary
      to keep Wayland as an option on nvidia >= 470 (both desktops and laptops).
    - Add Drop-special-handling-of-nvidia-hybrid-laptops.patch
      Align nvidia hybrid laptops with nvidia desktops: that means
      disabling Wayland on nvidia < 470 and keeping it opt-in on nvidia >= 470.
      Upstream also did this with GNOME 47, with the difference that there the
      desktop defaults are different.

  [ Nathan Pratta Teodosio ]
  * Rewrite xresources_is_a_dir.patch.
    To fix failure to load files in /etc/X11/Xresources (in case the latter is
    a directory instead of a regular file). (LP: #1955850)

 -- Marco Trevisan (Treviño) <marco@ubuntu.com>  Mon, 02 Dec 2024 23:47:57 +0100

gdm3 (46.2-1ubuntu1) oracular; urgency=medium

  * Merge with Debian, containing new upstream release. Remaining changes:
    + readme.debian: update for correct paths in ubuntu
    + control.in:
      - don't recommend desktop-base
      - depend on bash for config_error_dialog.patch
      - update vcs field
    + rules:
      - don't override default user/group
      - -dgdm-xsession=true to install upstream xsession script
      - override dh_installinit with --no-start to avoid session being killed
    + rules, readme.debian, gdm3.8.pod:
      use upstream custom.conf instead of daemon.conf
    + gdm3.{postinst,postrm}: rename user and group back to gdm
    + debian/tests/control:
      - Use gdm user name
      - Use needs-root instead of needs-sudo (to remove when ubuntu autopkgtest
        will be updated to include such feature)
    + debian/tests/sssd-gdm-smartcard-pam-auth-tester-env.sh:
      - Added to use needs-root autopkgtest instead of needs-sudo
    + gdm3.*.pam: make pam_env read ~/.pam_environment, as we use in g-c-c
      settings
    + gdm3.install:
      - don't install debian/xsession
    + add run_xsession.d.patch
    + add xresources_is_a_dir.patch
      - fix loading from /etc/x11/xresources/*
    + add nvidia_prime.patch:
      - add hook to run prime-offload (as root) and prime-switch if
        nvidia-prime is installed
    + add revert_override_lang_with_accountservices.patch:
      - on ubuntu accountservices only stores the language and not the
        full locale as needed by lang.
    + add dont_set_language_env.patch:
      - don't run the set_up_session_language() function, since it
        overrides variable values set by ~/.pam_environment
    + add config_error_dialog.patch:
      - show warning dialog in case of error in ~/.profile etc. and
        don't let a syntax error make the login fail
    + add debian/patches/revert_nvidia_wayland_blacklist.patch:
      - don't blacklist nvidia for wayland
    + add gdm3.service-wait-for-drm-device-before-trying-to-start-i.patch:
      - wait for the first valid gdm device on pre-start
    + add prefer_ubuntu_session_fallback.patch:
      - Prefer ubuntu session as fallback instead of GNOME
    + add XSession-Use-x-terminal-emulator-as-fallback-instead-of-x.patch:
      - Use x-terminal-emulator as fallback instead of xterm
    + add Revert-data-Disable-GDM-on-hybrid-graphics-laptops-with-v.patch:
      - Ensure Nvidia 5xx drivers always get Wayland as the default unless
        there's a stronger reason why it won't work (like modeset has been
        disabled on the kernel command line)
    + add debian/default.pa
      - disable bluetooth audio devices in pulseaudio from gdm3.
    + debian/gdm3.install
      - added details of the default.pa file
    + debian/gdm3.postinst
      - added installation of default.pa and creation of dir if it doesn't
        exist.
    + debian/greeter.dconf-defaults: don't set debian settings in the
      greeter's dconf db
    * Reverted debian patch to udev rules for nvidia S0ix suspend support

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 01 Jul 2024 08:15:29 -0400

gdm3 (46.2-1) unstable; urgency=medium

  [ Jeremy Bícha ]
  * New upstream release
  * Drop 2 patches applied in new release

  [ Sebastian Andrzej Siewior ]
  * Adapt autopkgtest for openssl3.2 (Closes: #1061458)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 01 Jul 2024 07:45:23 -0400

gdm3 (46.0-2ubuntu2) oracular; urgency=medium



=== debian/control ===
Source: gdm3
Section: gnome
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
Uploaders: Jeremy Bicha <jbicha@ubuntu.com>, Marco Trevisan (Treviño) <marco@ubuntu.com>
Build-Depends: check (>= 0.9.4),
               dconf-cli (>= 0.19.90),
               debhelper-compat (= 13),
               dh-exec,
               dh-sequence-gir,
               dh-sequence-gnome,
               docbook-xml,
               gettext (>= 0.19.8),
               gjs [amd64 armel arm64 armhf i386 loong64 mips64el mipsel ppc64el s390x riscv64],
               gnome-pkg-tools (>= 0.16.3),
               gnome-settings-daemon-dev (>= 3.24.0),
               gobject-introspection (>= 0.10.7-1~),
               intltool,
               iso-codes,
               itstool,
               libaccountsservice-dev (>= 0.6.35),
               libaudit-dev [linux-any],
               libcanberra-gtk3-dev (>= 0.4),
               libgirepository1.0-dev (>= 0.9.12),
               libglib2.0-dev (>= 2.44.0),
               libgtk-3-dev (>= 2.91.1),
               libgudev-1.0-dev (>= 232),
               libjson-glib-dev,
               libkeyutils-dev [linux-any],
               libpam0g-dev,
               libplymouth-dev [linux-any],
               libselinux1-dev [linux-any],
               libsystemd-dev [linux-any],
               libwrap0-dev,
               libx11-dev,
               libxau-dev,
               libxcb1-dev,
               libxdmcp-dev,
               meson (>= 0.57),
               pkgconf,
               systemd-dev,
Standards-Version: 4.6.2
XS-Debian-Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git
XS-Debian-Vcs-Browser: https://salsa.debian.org/gnome-team/gdm
Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git -b ubuntu/noble
Vcs-Browser: https://salsa.debian.org/gnome-team/gdm/tree/ubuntu/noble
Rules-Requires-Root: no
Homepage: https://wiki.gnome.org/Projects/GDM/

Package: gdm3
Architecture: amd64 arm64 armel armhf i386 loong64 mips64el mipsel ppc64el s390x riscv64
Depends: accountsservice (>= 0.6.35),
         adduser,
         bash (>= 4.3),
         dconf-cli (>= 0.20),
         dconf-gsettings-backend (>= 0.20),
         dbus-bin | systemd-sysv,
         dbus-daemon,
         default-dbus-system-bus | dbus-system-bus,
         default-logind [linux-any] | logind [linux-any],
         gir1.2-gdm-1.0 (= ${binary:Version}),
         ubuntu-session | gnome-session | x-session-manager | x-window-manager | x-terminal-emulator,
         gnome-session-bin (>= 3.37.0),
         gnome-session-common (>= 3.37.0-2~),
         gnome-settings-daemon (>= 3.37.0),
         gnome-shell (>= 3.37.90),
         gsettings-desktop-schemas,
         libgdm1 (= ${binary:Version}),
         libglib2.0-bin (>= 2.35.0),
         libpam-modules (>= 0.72-1),
         libpam-runtime (>= 0.76-13.1),
         librsvg2-common,
         polkitd [linux-any],
         procps,
         ucf,
         x11-common (>= 1:7.6+11),
         x11-xserver-utils,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: at-spi2-core,
            ubuntu-session | gnome-session | x-session-manager,
            x11-xkb-utils,
            xserver-xephyr,
            xserver-xorg,
            zenity
Suggests: orca,
          libpam-fprintd (>= 0.8.0-2),
          libpam-sss (>= 2.3.0-1),
          libpam-pkcs11,
          libpam-gnome-keyring
Provides: x-display-manager
Description: GNOME Display Manager
 GDM provides the equivalent of a "login:" prompt for X displays: it
 asks for a login and starts graphical sessions.
 .
 It supports multiple seats and switching between multiple users.
 .
 The greeter is based on the GNOME libraries and applications, and its
 look and design are the same as those of a GNOME session.

Package: libgdm1
Section: libs
Architecture: linux-any
Depends: ${gir:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: GNOME Display Manager (shared library)
 GDM provides the equivalent of a "login:" prompt for X displays: it
 asks for a login and starts graphical sessions.
 .
 It supports multiple seats and switching between multiple users.
 .
 The greeter is based on the GNOME libraries and applications, and its
 look and design are the same as those of a GNOME session.
 .
 This package contains the shared library required by gnome-shell.

Package: libgdm-dev
Section: libdevel
Architecture: linux-any
Depends: gir1.2-gdm-1.0 (= ${binary:Version}),
         libgdm1 (= ${binary:Version}),
         libglib2.0-dev (>= 2.44.0),
         ${gir:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Description: GNOME Display Manager (development files)
 GDM provides the equivalent of a "login:" prompt for X displays: it
 asks for a login and starts graphical sessions.
 .
 It supports multiple seats and switching between multiple users.
 .
 The greeter is based on the GNOME libraries and applications, and its
 look and design are the same as those of a GNOME session.
 .
 This package contains header and development files.

Package: gir1.2-gdm-1.0
Section: introspection
Architecture: linux-any
Depends: ${gir:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Conflicts: gir1.2-gdm3
Replaces: gir1.2-gdm3
Description: GObject introspection data for the GNOME Display Manager
 GDM provides the equivalent of a "login:" prompt for X displays: it
 asks for a login and starts graphical sessions.
 .
 It supports multiple seats and switching between multiple users.
 .
 The greeter is based on the GNOME libraries and applications, and its
 look and design are the same as those of a GNOME session.
 .
 This package contains introspection data for the GNOME Display Manager.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk
include /usr/share/gnome-pkg-tools/1/rules/gnome-version.mk

built_binaries := $(shell dh_listpackages)

export systemdsystemunitdir = $(shell pkgconf --variable=systemdsystemunitdir systemd | sed s,^/,,)
export udevdir = $(shell pkgconf --variable=udevdir udev | sed s,^/,,)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,defs

ifeq (linux,$(DEB_HOST_ARCH_OS))
CONFFLAGS += \
	-Dselinux=enabled \
	-Dplymouth=enabled
else
CONFFLAGS += \
	-Dwayland-support=false \
	-Dselinux=disabled
endif

ifneq (,$(filter debug,$(DEB_BUILD_OPTIONS)))
CONFFLAGS += --buildtype=debug
endif

pod2man := pod2man --release="GNOME $(DEB_GNOME_VERSION)" --center="Debian GNU/Linux"
PODFILES := $(wildcard debian/*.pod)
MANPAGES := $(patsubst %.pod,%,$(PODFILES))

debian/%: debian/%.pod
	$(pod2man) --section=$(shell echo $@ | sed 's/.*\.//') \
		$< | sed -e 's/debian:://' >$@

%:
	dh $@

# We set this up manually
override_dh_installsystemd:

override_dh_auto_configure:
	X_BIN="/usr/bin/Xorg" \
	dh_auto_configure -- \
		-Ddistro=debian \
		-Dipv6=true \
		-Dat-spi-registryd-dir=/usr/lib/at-spi \
		-Ddefault-path=/usr/local/bin:/usr/bin:/bin:/usr/games \
		-Dsysconfsubdir=gdm3 \
		-Dworking-dir=/var/lib/gdm3 \
		-Dxauth-dir=/run/gdm3 \
		-Drun-dir=/run/gdm3 \
		-Dpid-file=/run/gdm3.pid \
		-Dlog-dir=/var/log/gdm3 \
		-Dgdm-xsession=true \
		-Dpam-mod-dir=/usr/lib/$(DEB_HOST_MULTIARCH)/security \
		-Dscreenshot-dir=/run/gdm3/greeter \
		-Ddefaults-conf=/usr/share/gdm/defaults.conf \
		-Dlang-file=/etc/default/locale \
		-Dran-once-marker-dir=/run/gdm3 \
		-Dgnome-settings-daemon-dir="`pkg-config --variable=libexecdir gnome-settings-daemon`" \
		$(CONFFLAGS)

override_dh_auto_build: $(OUTFILES) $(MANPAGES)
	dh_auto_build

override_dh_install:
	dh_install
ifneq ($(filter gdm3,$(built_binaries)),)
	mv debian/gdm3/usr/sbin/gdm debian/gdm3/usr/sbin/gdm3
#	chmod 755 debian/gdm3/etc/gdm3/Xsession
	chmod 755 debian/gdm3/usr/share/gdm/generate-config
	dh_installpam -pgdm3 --name=gdm-autologin
	dh_installpam -pgdm3 --name=gdm-launch-environment
	dh_installpam -pgdm3 --name=gdm-password
	dh_installpam -pgdm3 --name=gdm-fingerprint
	dh_installpam -pgdm3 --name=gdm-smartcard-sssd-exclusive
	dh_installpam -pgdm3 --name=gdm-smartcard-sssd-or-password
	dh_installpam -pgdm3 --name=gdm-smartcard-pkcs11-exclusive
endif

override_dh_missing:
	dh_missing --fail-missing

override_dh_makeshlibs:
	dh_makeshlibs -- -c4

override_dh_installinit:
	dh_installinit --noscripts --no-start

override_dh_auto_clean:
	dh_auto_clean
	rm -f $(MANPAGES)
	rm -f $(OUTFILES)
	rm -f data/gdm.schemas data/61-gdm.rules

override_dh_gnome_clean:

=== debian/tests/control ===
Test-Command: env
  OFFLINE_MODE=1
  GDM_USER=gdm
  bash debian/tests/sssd-gdm-smartcard-pam-auth-tester-env.sh
Features: test-name=sssd-gdm-smartcard-auth-test
Classes: desktop
Depends: adduser,
         bash,
         gdm3,
         gnutls-bin,
         libpam-sss,
         openssl,
         pamtester,
         passwd,
         softhsm2,
         sssd,
         sudo,
         util-linux
Restrictions: breaks-testbed,
              isolation-container,
              needs-root,
              allow-stderr

## gdm3 47.0

=== debian/changelog ===
gdm3 (47.0-1ubuntu2.24.10.1) oracular; urgency=medium

  [ Marco Trevisan (Treviño) ]
  * debian: Prepare for ubuntu/oracular branching

  [ Nathan Pratta Teodosio ]
  * Rewrite xresources_is_a_dir.patch.
    To fix failure to load files in /etc/X11/Xresources (in case the latter is
    a directory instead of a regular file). (LP: #1955850)

 -- Marco Trevisan (Treviño) <marco@ubuntu.com>  Tue, 03 Dec 2024 00:03:20 +0100

gdm3 (47.0-1ubuntu2) oracular; urgency=medium

  [ Daniel van Vugt ]
  * Clean up Nvidia/Wayland/Xorg decision making.
    1. Drop `Revert-data-Revert-part-of-wayland-hybrid-graphics-change.patch`
       because its only purpose was to disable Wayland on hybrid machines,
       which we don't want.
    2. Drop `Revert-data-Remove-nvidia-driver-version-check.patch` because it
       introduced three bugs:
       - `GOTO="gdm_prefer_xorg"` which no longer exists (LP: #2081635)
       - `For nvidia drivers versions 470-495, prefer Xorg by default` is
         wrong because Wayland support for 470 was reinstated in Mutter 47.c
         resolving https://gitlab.gnome.org/GNOME/mutter/-/issues/3196
       - `"[5-9][1-9][0-9].*"` will eventually fail to recognise 60x and 70x
         as higher than 510.
       and does nothing useful beyond that.
    3. Fix `Revert-data-Disable-GDM-on-hybrid-graphics-laptops-with-v.patch`
       conflicts arising from dropping the other patches.
    4. Rename `Revert-data-Disable-GDM-on-hybrid-graphics-laptops-with-v.patch`
       to `Drop-Nvidia-power-management-suspend-checks.patch` and update its
       description with a more accurate justification for the patch still
       existing.

 -- Marco Trevisan (Treviño) <marco@ubuntu.com>  Thu, 26 Sep 2024 00:27:09 +0200

gdm3 (47.0-1ubuntu1) oracular; urgency=medium

  * Merge with Debian, containing new upstream release. Remaining changes:
    + readme.debian: update for correct paths in ubuntu
    + control.in:
      - don't recommend desktop-base
      - depend on bash for config_error_dialog.patch
      - update vcs field
    + rules:
      - don't override default user/group
      - -dgdm-xsession=true to install upstream xsession script
      - override dh_installinit with --no-start to avoid session being killed
    + rules, readme.debian, gdm3.8.pod:
      use upstream custom.conf instead of daemon.conf
    + gdm3.{postinst,postrm}: rename user and group back to gdm
    + debian/tests/control:
      - Use gdm user name
      - Use needs-root instead of needs-sudo (to remove when ubuntu autopkgtest
        will be updated to include such feature)
    + debian/tests/sssd-gdm-smartcard-pam-auth-tester-env.sh:
      - Added to use needs-root autopkgtest instead of needs-sudo
    + gdm3.*.pam: make pam_env read ~/.pam_environment, as we use in g-c-c
      settings
    + gdm3.install:
      - don't install debian/xsession
    + add run_xsession.d.patch
    + add xresources_is_a_dir.patch
      - fix loading from /etc/x11/xresources/*
    + add nvidia_prime.patch:
      - add hook to run prime-offload (as root) and prime-switch if
        nvidia-prime is installed
    + add revert_override_lang_with_accountservices.patch:
      - on ubuntu accountservices only stores the language and not the
        full locale as needed by lang.
    + add dont_set_language_env.patch:
      - don't run the set_up_session_language() function, since it
        overrides variable values set by ~/.pam_environment
    + add config_error_dialog.patch:
      - show warning dialog in case of error in ~/.profile etc. and
        don't let a syntax error make the login fail
    + add debian/patches/revert_nvidia_wayland_blacklist.patch:
      - don't blacklist nvidia for wayland
    + add gdm3.service-wait-for-drm-device-before-trying-to-start-i.patch:
      - wait for the first valid gdm device on pre-start
    + add prefer_ubuntu_session_fallback.patch:
      - Prefer ubuntu session as fallback instead of GNOME
    + add XSession-Use-x-terminal-emulator-as-fallback-instead-of-x.patch:
      - Use x-terminal-emulator as fallback instead of xterm
    + add Revert-data-Disable-GDM-on-hybrid-graphics-laptops-with-v.patch:
      - Ensure Nvidia 5xx drivers always get Wayland as the default unless
        there's a stronger reason why it won't work (like modeset has been
        disabled on the kernel command line)
    + add debian/default.pa
      - disable bluetooth audio devices in pulseaudio from gdm3.
    + debian/gdm3.install
      - added details of the default.pa file
    + debian/gdm3.postinst
      - added installation of default.pa and creation of dir if it doesn't
        exist.
    + debian/greeter.dconf-defaults: don't set debian settings in the
      greeter's dconf db
    * Reverted debian patch to udev rules for nvidia S0ix suspend support
  * debian/patches: Revert a further upstream change to gdm udev rules
  * debian/patches: Update git indexes

 -- Marco Trevisan (Treviño) <marco@ubuntu.com>  Mon, 16 Sep 2024 19:05:58 +0200

gdm3 (47.0-1) experimental; urgency=medium

  [ Simon McVittie ]
  * New upstream release candidate 47
  * d/rules: Explicitly enable X11 support.
    If upstream disables this in some future release, we'll want it to be
    an intentional decision whether we follow that.
  * d/control: Drop dependency on libcanberra-gtk, no longer checked
  * d/control: Don't build gdm3 binary package on armel.
    gdm3 requires GNOME Shell, which is unlikely to be practically useful
    on the older ARM machines that can't run armhf or arm64. GNOME Shell
    also requires gjs, which is likely to be removed from armel.
    (Helps: #1080521)
  * Standards-Version: 4.7.0 (no changes required)
  * Update Lintian overrides
  * d/control: Add ${gir:Provides} to libgdm-dev

  [ Marco Trevisan (Treviño) ]
  * New upstream release 47.0
  * debian: Drop gdm-screenshot references, as it has been removed upstream

 -- Marco Trevisan (Treviño) <marco@ubuntu.com>  Mon, 16 Sep 2024 17:32:15 +0200

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
                dh-sequence-gnome,
                docbook-xml,
                gettext (>= 0.19.8),
-               gjs [amd64 armel arm64 armhf i386 loong64 mips64el mipsel ppc64el s390x riscv64],
+               gjs [amd64 arm64 armhf i386 loong64 mips64el mipsel ppc64el s390x riscv64],
                gnome-pkg-tools (>= 0.16.3),
                gnome-settings-daemon-dev (>= 3.24.0),
                gobject-introspection (>= 0.10.7-1~),
@@ -21,7 +21,6 @@
                itstool,
                libaccountsservice-dev (>= 0.6.35),
                libaudit-dev [linux-any],
-               libcanberra-gtk3-dev (>= 0.4),
                libgirepository1.0-dev (>= 0.9.12),
                libglib2.0-dev (>= 2.44.0),
                libgtk-3-dev (>= 2.91.1),
@@ -40,16 +39,16 @@
                meson (>= 0.57),
                pkgconf,
                systemd-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 XS-Debian-Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git
 XS-Debian-Vcs-Browser: https://salsa.debian.org/gnome-team/gdm
-Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git -b ubuntu/noble
-Vcs-Browser: https://salsa.debian.org/gnome-team/gdm/tree/ubuntu/noble
+Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git -b ubuntu/oracular
+Vcs-Browser: https://salsa.debian.org/gnome-team/gdm/tree/ubuntu/oracular
 Rules-Requires-Root: no
 Homepage: https://wiki.gnome.org/Projects/GDM/
 
 Package: gdm3
-Architecture: amd64 arm64 armel armhf i386 loong64 mips64el mipsel ppc64el s390x riscv64
+Architecture: amd64 arm64 armhf i386 loong64 mips64el mipsel ppc64el s390x riscv64
 Depends: accountsservice (>= 0.6.35),
          adduser,
          bash (>= 4.3),
@@ -125,6 +124,7 @@
          ${gir:Depends},
          ${misc:Depends},
          ${shlibs:Depends}
+Provides: ${gir:Provides}
 Description: GNOME Display Manager (development files)
  GDM provides the equivalent of a "login:" prompt for X displays: it
  asks for a login and starts graphical sessions.

## gdm3 48~beta

=== debian/changelog ===
gdm3 (48~beta-1ubuntu1) plucky; urgency=medium

  * Merge with Debian. Remaining changes:
    + readme.debian: update for correct paths in ubuntu
    + control:
      - don't recommend desktop-base
      - depend on bash for config_error_dialog.patch
      - update vcs field
    + rules:
      - don't override default user/group
      - -dgdm-xsession=true to install upstream xsession script
      - override dh_installinit with --no-start to avoid session being killed
    + rules, readme.debian, gdm3.8.pod:
      use upstream custom.conf instead of daemon.conf
    + gdm3.{postinst,postrm}: rename user and group back to gdm
    + debian/tests/control:
      - Use gdm user name
    + gdm3.*.pam: make pam_env read ~/.pam_environment, as we use in g-c-c
      settings
    + gdm3.install:
      - don't install debian/xsession
    + add run_xsession.d.patch
    + add xresources_is_a_dir.patch
      - fix loading from /etc/x11/xresources/*
    + add nvidia_prime.patch:
      - add hook to run prime-offload (as root) and prime-switch if
        nvidia-prime is installed
    + add revert_override_lang_with_accountservices.patch:
      - on ubuntu accountservices only stores the language and not the
        full locale as needed by lang.
    + add dont_set_language_env.patch:
      - don't run the set_up_session_language() function, since it
        overrides variable values set by ~/.pam_environment
    + add config_error_dialog.patch:
      - show warning dialog in case of error in ~/.profile etc. and
        don't let a syntax error make the login fail
    + add prefer_ubuntu_session_fallback.patch:
      - Prefer ubuntu session as fallback instead of GNOME
    + add XSession-Use-x-terminal-emulator-as-fallback-instead-of-x.patch:
      - Use x-terminal-emulator as fallback instead of xterm
    + add Drop-Nvidia-power-management-suspend-checks.patch:
      - Ensure Nvidia drivers always get Wayland as the default, despite
        known issues with suspend/resume affecting Wayland more than Xorg.
    + add debian/default.pa
      - disable bluetooth audio devices in pulseaudio from gdm3.
    + debian/gdm3.install
      - added details of the default.pa file
    + debian/gdm3.postinst
      - added installation of default.pa and creation of dir if it doesn't
        exist.
    + debian/greeter.dconf-defaults: don't set debian settings in the
      greeter's dconf db

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 10 Feb 2025 10:56:26 -0500

gdm3 (48~beta-1) unstable; urgency=medium

  [ Jeremy Bícha ]
  * New upstream release
  * Remove gsettings schema patch: applied in new release

  [ Marco Trevisan (Treviño) ]
  * debian/tests/sssd-gdm: Use random PIN values by default
  * debian/tests/sssd-gdm: Sync with upstream cleanups
  * d/tests/sssd-gdm-smartcard-pam-auth-tester.sh: Ensure auth fails
    with invalid cert
  * debian/tests/sssd-softhism2-certificates-tests.sh: Remove unused
    v3_ca settings

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 10 Feb 2025 10:47:28 -0500

gdm3 (47.0-4) unstable; urgency=medium

  * Cherry-pick gsettings schema addition required by GNOME Shell 48 Beta

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 05 Feb 2025 08:11:50 -0500

gdm3 (47.0-3ubuntu2) plucky; urgency=medium

  * d/p/u/xresources_is_a_dir.patch rewritten to fix failure to load files in
    /etc/X11/Xresources (in case the latter is a directory instead of a
    regular file). LP: #1955850.

 -- Nathan Pratta Teodosio <nteodosio@ubuntu.com>  Mon, 02 Dec 2024 15:10:47 +0100

gdm3 (47.0-3ubuntu1) plucky; urgency=medium

  * Merge with Debian. Remaining changes:
    + readme.debian: update for correct paths in ubuntu
    + control:
      - don't recommend desktop-base
      - depend on bash for config_error_dialog.patch
      - update vcs field
    + rules:
      - don't override default user/group
      - -dgdm-xsession=true to install upstream xsession script
      - override dh_installinit with --no-start to avoid session being killed
    + rules, readme.debian, gdm3.8.pod:
      use upstream custom.conf instead of daemon.conf
    + gdm3.{postinst,postrm}: rename user and group back to gdm
    + debian/tests/control:
      - Use gdm user name
    + gdm3.*.pam: make pam_env read ~/.pam_environment, as we use in g-c-c
      settings
    + gdm3.install:
      - don't install debian/xsession
    + add run_xsession.d.patch
    + add xresources_is_a_dir.patch
      - fix loading from /etc/x11/xresources/*
    + add nvidia_prime.patch:
      - add hook to run prime-offload (as root) and prime-switch if
        nvidia-prime is installed
    + add revert_override_lang_with_accountservices.patch:
      - on ubuntu accountservices only stores the language and not the
        full locale as needed by lang.
    + add dont_set_language_env.patch:
      - don't run the set_up_session_language() function, since it
        overrides variable values set by ~/.pam_environment
    + add config_error_dialog.patch:
      - show warning dialog in case of error in ~/.profile etc. and
        don't let a syntax error make the login fail
    + add prefer_ubuntu_session_fallback.patch:
      - Prefer ubuntu session as fallback instead of GNOME
    + add XSession-Use-x-terminal-emulator-as-fallback-instead-of-x.patch:
      - Use x-terminal-emulator as fallback instead of xterm
    + add Drop-Nvidia-power-management-suspend-checks.patch:
      - Ensure Nvidia drivers always get Wayland as the default, despite
        known issues with suspend/resume affecting Wayland more than Xorg.
    + add debian/default.pa
      - disable bluetooth audio devices in pulseaudio from gdm3.
    + debian/gdm3.install
      - added details of the default.pa file
    + debian/gdm3.postinst
      - added installation of default.pa and creation of dir if it doesn't
        exist.
    + debian/greeter.dconf-defaults: don't set debian settings in the
      greeter's dconf db
  * Ubuntu can now use needs-sudo in autopkgtest like Debian.



## gdm3 48.0

=== meson_options.txt ===
--- 
+++ 
@@ -38,5 +38,6 @@
 option('user-display-server', type: 'boolean', value: true, description: 'Enable running X server as user.')
 option('wayland-support', type: 'boolean', value: true, description: 'Enable support for wayland sessions.')
 option('working-dir', type: 'string', value: '', description: 'Working directory.')
+option('x11-support', type: 'boolean', value: true, description: 'Enable support for x11 sessions.')
 option('xauth-dir', type: 'string', value: '', description: 'XAuth cookie directory.')
 option('xdmcp', type: 'feature', value: 'auto', description: 'Add XDMCP (remote login) support.')

=== debian/changelog ===
gdm3 (48.0-2) unstable; urgency=medium

  * Team upload
  * d/greeter.dconf-defaults: Remove non-functional theming options.
    The visual design of the greeter (login prompt) is no longer intended
    to be configurable, and in particular the background is no longer
    configurable, so none of the background-related settings have any
    effect. The greeter also does not use GTK, so changing the GTK
    theme has no effect on it.
    Remove these options from the default configuration file so that
    they will not mislead sysadmins. (Closes: #1105057)
  * d/greeter.dconf-defaults: Add some useful example options.
    Disabling fingerprint authentication is one of the examples given
    in the GNOME System Administration Guide. The steps from that guide
    won't actually work as-is on Debian (because we use a different
    username for the greeter, #1107944) but we can make it as easy as
    possible to do the equivalent.
    Meanwhile, disabling smartcard authentication is a way to avoid the
    presence of a smartcard having the side-effect of disabling the user
    list, and in some configurations also the ability to log in with a
    password (#1051785).
  * d/gdm3.alternatives: When smart card authentication is re-enabled,
    make gdm-smartcard-sssd-or-password the default.
    With the previous default, gdm-smartcard-sssd-exclusive, if a smart
    card was plugged in and libpam-sss was installed, we would reject
    attempts to log in with a password. This is the most-hardened choice
    if smart cards are being used for authentication, but prevents login
    if the smart card has not been enrolled for authentication and is
    actually being used for some other purpose such as OpenPGP or X509.
    (Closes: #1051785)
  * d/greeter.dconf-defaults: Disable smartcard authentication by default.
    Enabling smartcard authentication has side-effects on other aspects of
    greeter behaviour if a compatible smartcard happens to be connected:
    in particular, it disables the user list, resulting in users being
    required to type their username to log in.
    Enrolling smartcards to be used for authentication requires sysadmin
    action, so it seems reasonable to require the sysadmin to take action
    to enable it after they have done the necessary enrolment step.
    (Closes: #1051785)
  * d/p/gdm-settings-utils-rename-variable-to-fix-build-with-gcc-.patch:
    Add patch from upstream 49.alpha.0 to fix FTBFS in C23 mode.
    This won't become relevant until gcc 15 becomes the default during
    the forky cycle, but is a harmless change while we're uploading anyway.
    (Closes: #1096689)

 -- Simon McVittie <smcv@debian.org>  Sun, 13 Jul 2025 20:08:32 +0100

gdm3 (48.0-1) unstable; urgency=medium

  * New upstream release
  * debian/gdm3.install: Install new polkit rules to allow changing
    global network settings from the login screen (LP: #2098016)

 -- Jeremy Bícha <jbicha@ubuntu.com>  Mon, 17 Mar 2025 12:33:51 -0400

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: gdm3
 Section: gnome
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
-Uploaders: Jeremy Bicha <jbicha@ubuntu.com>, Marco Trevisan (Treviño) <marco@ubuntu.com>
+Maintainer: Debian GNOME Maintainers <pkg-gnome-maintainers@lists.alioth.debian.org>
+Uploaders: Jeremy Bícha <jbicha@ubuntu.com>, Laurent Bigonville <bigon@debian.org>, Marco Trevisan (Treviño) <marco@ubuntu.com>
 Build-Depends: check (>= 0.9.4),
                dconf-cli (>= 0.19.90),
                debhelper-compat (= 13),
@@ -40,10 +39,8 @@
                pkgconf,
                systemd-dev,
 Standards-Version: 4.7.0
-XS-Debian-Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git
-XS-Debian-Vcs-Browser: https://salsa.debian.org/gnome-team/gdm
-Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git -b ubuntu/oracular
-Vcs-Browser: https://salsa.debian.org/gnome-team/gdm/tree/ubuntu/oracular
+Vcs-Browser: https://salsa.debian.org/gnome-team/gdm
+Vcs-Git: https://salsa.debian.org/gnome-team/gdm.git
 Rules-Requires-Root: no
 Homepage: https://wiki.gnome.org/Projects/GDM/
 
@@ -51,7 +48,6 @@
 Architecture: amd64 arm64 armhf i386 loong64 mips64el mipsel ppc64el s390x riscv64
 Depends: accountsservice (>= 0.6.35),
          adduser,
-         bash (>= 4.3),
          dconf-cli (>= 0.20),
          dconf-gsettings-backend (>= 0.20),
          dbus-bin | systemd-sysv,
@@ -59,7 +55,7 @@
          default-dbus-system-bus | dbus-system-bus,
          default-logind [linux-any] | logind [linux-any],
          gir1.2-gdm-1.0 (= ${binary:Version}),
-         ubuntu-session | gnome-session | x-session-manager | x-window-manager | x-terminal-emulator,
+         gnome-session | x-session-manager | x-window-manager | x-terminal-emulator,
          gnome-session-bin (>= 3.37.0),
          gnome-session-common (>= 3.37.0-2~),
          gnome-settings-daemon (>= 3.37.0),
@@ -78,7 +74,8 @@
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: at-spi2-core,
-            ubuntu-session | gnome-session | x-session-manager,
+            desktop-base (>= 10.0.0),
+            gnome-session | x-session-manager,
             x11-xkb-utils,
             xserver-xephyr,
             xserver-xorg,

=== debian/rules ===
--- 
+++ 
@@ -48,19 +48,21 @@
 		-Dipv6=true \
 		-Dat-spi-registryd-dir=/usr/lib/at-spi \
 		-Ddefault-path=/usr/local/bin:/usr/bin:/bin:/usr/games \
+		-Dcustom-conf=/etc/gdm3/daemon.conf \
 		-Dsysconfsubdir=gdm3 \
 		-Dworking-dir=/var/lib/gdm3 \
 		-Dxauth-dir=/run/gdm3 \
 		-Drun-dir=/run/gdm3 \
 		-Dpid-file=/run/gdm3.pid \
 		-Dlog-dir=/var/log/gdm3 \
-		-Dgdm-xsession=true \
 		-Dpam-mod-dir=/usr/lib/$(DEB_HOST_MULTIARCH)/security \
 		-Dscreenshot-dir=/run/gdm3/greeter \
 		-Ddefaults-conf=/usr/share/gdm/defaults.conf \
+		-Duser=Debian-gdm -Dgroup=Debian-gdm \
 		-Dlang-file=/etc/default/locale \
 		-Dran-once-marker-dir=/run/gdm3 \
 		-Dgnome-settings-daemon-dir="`pkg-config --variable=libexecdir gnome-settings-daemon`" \
+		-Dx11-support=true \
 		$(CONFFLAGS)
 
 override_dh_auto_build: $(OUTFILES) $(MANPAGES)
@@ -70,7 +72,7 @@
 	dh_install
 ifneq ($(filter gdm3,$(built_binaries)),)
 	mv debian/gdm3/usr/sbin/gdm debian/gdm3/usr/sbin/gdm3
-#	chmod 755 debian/gdm3/etc/gdm3/Xsession
+	chmod 755 debian/gdm3/etc/gdm3/Xsession
 	chmod 755 debian/gdm3/usr/share/gdm/generate-config
 	dh_installpam -pgdm3 --name=gdm-autologin
 	dh_installpam -pgdm3 --name=gdm-launch-environment
@@ -88,7 +90,7 @@
 	dh_makeshlibs -- -c4
 
 override_dh_installinit:
-	dh_installinit --noscripts --no-start
+	dh_installinit --noscripts
 
 override_dh_auto_clean:
 	dh_auto_clean

=== debian/watch ===
version=4
opts="searchmode=plain, uversionmangle=s/\.(alpha|beta|rc)/~$1/, downloadurlmangle=s|cache.json||" \
https://download.gnome.org/sources/gdm/cache.json \
	[\d.]+/gdm-([\d.]+\.?(?:beta|rc)?[\d.]*)@ARCHIVE_EXT@

## gdm3 49~alpha.0

=== meson_options.txt ===
--- 
+++ 
@@ -38,6 +38,6 @@
 option('user-display-server', type: 'boolean', value: true, description: 'Enable running X server as user.')
 option('wayland-support', type: 'boolean', value: true, description: 'Enable support for wayland sessions.')
 option('working-dir', type: 'string', value: '', description: 'Working directory.')
-option('x11-support', type: 'boolean', value: true, description: 'Enable support for x11 sessions.')
+option('x11-support', type: 'boolean', value: false, description: 'Enable support for x11 sessions.')
 option('xauth-dir', type: 'string', value: '', description: 'XAuth cookie directory.')
 option('xdmcp', type: 'feature', value: 'auto', description: 'Add XDMCP (remote login) support.')
